/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ExtractionDebugResponseAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExtractionDebugResponseAllOf{}

// ExtractionDebugResponseAllOf struct for ExtractionDebugResponseAllOf
type ExtractionDebugResponseAllOf struct {
	Logs     []interface{}  `json:"logs,omitempty"`
	RowCount *int32         `json:"row_count,omitempty"`
	Blob     NullableString `json:"blob,omitempty"`
}

// NewExtractionDebugResponseAllOf instantiates a new ExtractionDebugResponseAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExtractionDebugResponseAllOf() *ExtractionDebugResponseAllOf {
	this := ExtractionDebugResponseAllOf{}
	return &this
}

// NewExtractionDebugResponseAllOfWithDefaults instantiates a new ExtractionDebugResponseAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExtractionDebugResponseAllOfWithDefaults() *ExtractionDebugResponseAllOf {
	this := ExtractionDebugResponseAllOf{}
	return &this
}

// GetLogs returns the Logs field value if set, zero value otherwise.
func (o *ExtractionDebugResponseAllOf) GetLogs() []interface{} {
	if o == nil || IsNil(o.Logs) {
		var ret []interface{}
		return ret
	}
	return o.Logs
}

// GetLogsOk returns a tuple with the Logs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionDebugResponseAllOf) GetLogsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Logs) {
		return nil, false
	}
	return o.Logs, true
}

// HasLogs returns a boolean if a field has been set.
func (o *ExtractionDebugResponseAllOf) HasLogs() bool {
	if o != nil && !IsNil(o.Logs) {
		return true
	}

	return false
}

// SetLogs gets a reference to the given []interface{} and assigns it to the Logs field.
func (o *ExtractionDebugResponseAllOf) SetLogs(v []interface{}) {
	o.Logs = v
}

// GetRowCount returns the RowCount field value if set, zero value otherwise.
func (o *ExtractionDebugResponseAllOf) GetRowCount() int32 {
	if o == nil || IsNil(o.RowCount) {
		var ret int32
		return ret
	}
	return *o.RowCount
}

// GetRowCountOk returns a tuple with the RowCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExtractionDebugResponseAllOf) GetRowCountOk() (*int32, bool) {
	if o == nil || IsNil(o.RowCount) {
		return nil, false
	}
	return o.RowCount, true
}

// HasRowCount returns a boolean if a field has been set.
func (o *ExtractionDebugResponseAllOf) HasRowCount() bool {
	if o != nil && !IsNil(o.RowCount) {
		return true
	}

	return false
}

// SetRowCount gets a reference to the given int32 and assigns it to the RowCount field.
func (o *ExtractionDebugResponseAllOf) SetRowCount(v int32) {
	o.RowCount = &v
}

// GetBlob returns the Blob field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExtractionDebugResponseAllOf) GetBlob() string {
	if o == nil || IsNil(o.Blob.Get()) {
		var ret string
		return ret
	}
	return *o.Blob.Get()
}

// GetBlobOk returns a tuple with the Blob field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExtractionDebugResponseAllOf) GetBlobOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Blob.Get(), o.Blob.IsSet()
}

// HasBlob returns a boolean if a field has been set.
func (o *ExtractionDebugResponseAllOf) HasBlob() bool {
	if o != nil && o.Blob.IsSet() {
		return true
	}

	return false
}

// SetBlob gets a reference to the given NullableString and assigns it to the Blob field.
func (o *ExtractionDebugResponseAllOf) SetBlob(v string) {
	o.Blob.Set(&v)
}

// SetBlobNil sets the value for Blob to be an explicit nil
func (o *ExtractionDebugResponseAllOf) SetBlobNil() {
	o.Blob.Set(nil)
}

// UnsetBlob ensures that no value is present for Blob, not even an explicit nil
func (o *ExtractionDebugResponseAllOf) UnsetBlob() {
	o.Blob.Unset()
}

func (o ExtractionDebugResponseAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExtractionDebugResponseAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Logs) {
		toSerialize["logs"] = o.Logs
	}
	if !IsNil(o.RowCount) {
		toSerialize["row_count"] = o.RowCount
	}
	if o.Blob.IsSet() {
		toSerialize["blob"] = o.Blob.Get()
	}
	return toSerialize, nil
}

type NullableExtractionDebugResponseAllOf struct {
	value *ExtractionDebugResponseAllOf
	isSet bool
}

func (v NullableExtractionDebugResponseAllOf) Get() *ExtractionDebugResponseAllOf {
	return v.value
}

func (v *NullableExtractionDebugResponseAllOf) Set(val *ExtractionDebugResponseAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableExtractionDebugResponseAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableExtractionDebugResponseAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExtractionDebugResponseAllOf(val *ExtractionDebugResponseAllOf) *NullableExtractionDebugResponseAllOf {
	return &NullableExtractionDebugResponseAllOf{value: val, isSet: true}
}

func (v NullableExtractionDebugResponseAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExtractionDebugResponseAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
